-- 爬塔入口
Lua_ClimbTowerEntranceWindow = class("Lua_ClimbTowerEntranceWindow", Lua_Window);
function Lua_ClimbTowerEntranceWindow:ctor()
	self:superCall("ctor");
	
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_ClimbTowerEntranceWindow";
	self.skinName = "ClimbTowerEntranceWindow_skin";
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.winBgPath = "/images/climb_tower/ui_ttt_bj_001.jpg";
	self.showBackBtn = true;
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_ClimbTowerEntranceWindow:buildShowItem()
	self:superCall("buildShowItem");

	local arr = DataCenter.climbTowerData.towerArr;
	local posDic = {{320, 655}, {-55, 422}, {320, 422}, {-55, 186}, {320, 186}};
	self.redPointArr = Array();
	local vo;
	local isFighting;
	local redPoint;
	for i = 1, arr:getSize() do
		vo = DataCenter.climbTowerData:getTowerVoById(arr[i]);
		isFighting = DataCenter.fightData:checkFightingByTemplateId(vo.fight_id);
		self["fighting_"..vo.id]:setEnable(isFighting);
		self["mask_"..vo.id]:setEnable(not vo.isOpened);
		self["openText_"..vo.id]:setEnable(not vo.isOpened);
		self["openText_"..vo.id].text = vo.open_str;
		self["layerText_"..vo.id].text = LanUtil.formateStr(201000, tostring(vo.cur_storey));

		if vo.isOpened then
			if arr[i] == 9 then
				redPoint = Lua_RedPointIcon.new(self["towerObject_"..vo.id], "ClimbTower_9", "ClimbTower_9_Daily");
			else
				redPoint = Lua_RedPointIcon.new(self["towerObject_"..vo.id], "ClimbTower_"..vo.id, "ClimbTower_"..vo.id.."_Login");
			end
			redPoint:setLocation(posDic[i][1], posDic[i][2], 0);
		end
		self.redPointArr:add(redPoint);
	end

	self.tower_9.clickScale = false;
	self.tower_9:addClickFuntion(self, self.onClick);
	self.tower_3.clickScale = false;
	self.tower_3:addClickFuntion(self, self.onClick);
	self.tower_2.clickScale = false;
	self.tower_2:addClickFuntion(self, self.onClick);
	self.tower_1.clickScale = false;
	self.tower_1:addClickFuntion(self, self.onClick);
	self.tower_4.clickScale = false;
	self.tower_4:addClickFuntion(self, self.onClick);
	
	self:addLuaEvent("FIGHTPLAY_ENTER", self, self.updateShowInfo);
	self:addLuaEvent("FIGHTPLAY_COMPLETE", self, self.updateShowInfo);
	self:addLuaEvent("UPDATE_TOWER_INFO", self, self.updateShowInfo);
	Lua_ProxyManager.getProxy("Lua_ClimbTowerProxy"):sTowerInfo(0);
end

function Lua_ClimbTowerEntranceWindow:dispose()
	if self.redPointArr ~= nil then
		self.redPointArr:dispose();
		self.redPointArr:clear();
		self.redPointArr = nil;
	end
	self:superCall("dispose");
end

function Lua_ClimbTowerEntranceWindow:updateShowInfo(towerId)
	local arr = DataCenter.climbTowerData.towerArr;
	local vo;
	local isFighting;
	for i = 1, arr:getSize() do
		vo = DataCenter.climbTowerData:getTowerVoById(arr[i]);
		isFighting = DataCenter.fightData:checkFightingByTemplateId(vo.fight_id);
		self["fighting_"..vo.id]:setEnable(isFighting);
		self["mask_"..vo.id]:setEnable(not vo.isOpened);
		self["openText_"..vo.id]:setEnable(not vo.isOpened);
		self["openText_"..vo.id].text = vo.open_str;
		self["layerText_"..vo.id].text = LanUtil.formateStr(201000, tostring(vo.cur_storey));
	end
end

function Lua_ClimbTowerEntranceWindow:onClick(go)
	local arr = string.split(go.name, "_");
	local towerId = tonumber(arr[2]);
	local vo = DataCenter.climbTowerData:getTowerVoById(towerId);

	if not DataCenter.funcOpenData:isOpened(vo.func_id, true) then
		return;
	end

	if not vo.isOpened then
		OperateAlert.show(vo.open_str..vo.name);
		return;
	end

	local isFighting = DataCenter.fightData:checkFightingByTemplateId(vo.fight_id);
	if isFighting then
		DataCenter.fightData:showFightToStage(vo.fight_id);
	end
	Lua_WindowUtil.openWin(vo.windowName, Lua_WinParam.ACTION_OPEN, towerId);

	if not strIsNullOrEmpty(vo.loginId) then
		DataCenter.redPointData:updateRedPointState(vo.loginId, false, true)
	end
end